/**
 * Copyright © 2023-2024 Agence du Numerique en Sante (ANS)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 *
 *
 *
 *
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

package com.hubsante.model.emsi;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.JsonValue;
import com.fasterxml.jackson.dataformat.xml.annotation.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Arrays;
import java.util.List;
import java.util.Objects;

/**
 * Rtype
 */
@JsonPropertyOrder({Rtype.JSON_PROPERTY_R_C_L_A_S_S,
                    Rtype.JSON_PROPERTY_C_A_P_A_B_I_L_I_T_Y,
                    Rtype.JSON_PROPERTY_C_H_A_R_A_C_T_E_R_I_S_T_I_C_S})
@JsonTypeName("rtype")
@JsonInclude(JsonInclude.Include.NON_EMPTY)

public class Rtype {

  /**
   * Permet d&#39;indiquer la classe de l&#39;objet RESOURCE. Plusieurs niveau
   * de détails sont fournis par la nomenclature associée. Le premier niveau
   * permet notamment de décrire la classe principale de ressource : - Un
   * véhicule, - Le personnel mobilisé, - Des consommables/ du matériel, - Un
   * lieu ou une organisation (non utilisé pour le moment) Voir nomenclature
   * EMSI associée
   */
  public enum RCLASSEnum {
    FAC("FAC"),

    HUM("HUM"),

    MAT("MAT"),

    ORG("ORG"),

    FAC_BRIDGE("FAC/BRIDGE"),

    FAC_BUILDN("FAC/BUILDN"),

    FAC_DEPOT("FAC/DEPOT"),

    FAC_NETWK("FAC/NETWK"),

    FAC_OPR("FAC/OPR"),

    FAC_OTH("FAC/OTH"),

    FAC_WATFIR("FAC/WATFIR"),

    FAC_BRIDGE_MILVHL("FAC/BRIDGE/MILVHL"),

    FAC_BUILDN_BARRCK("FAC/BUILDN/BARRCK"),

    FAC_BUILDN_BUNKER("FAC/BUILDN/BUNKER"),

    FAC_BUILDN_COB("FAC/BUILDN/COB"),

    FAC_BUILDN_CTT("FAC/BUILDN/CTT"),

    FAC_BUILDN_DAM("FAC/BUILDN/DAM"),

    FAC_BUILDN_GYMNAS("FAC/BUILDN/GYMNAS"),

    FAC_BUILDN_HANGAR("FAC/BUILDN/HANGAR"),

    FAC_BUILDN_HOUSE("FAC/BUILDN/HOUSE"),

    FAC_BUILDN_HUT("FAC/BUILDN/HUT"),

    FAC_BUILDN_INDINS("FAC/BUILDN/INDINS"),

    FAC_BUILDN_OFFICE("FAC/BUILDN/OFFICE"),

    FAC_BUILDN_SCHOOL("FAC/BUILDN/SCHOOL"),

    FAC_BUILDN_SHD("FAC/BUILDN/SHD"),

    FAC_BUILDN_SHLSUR("FAC/BUILDN/SHLSUR"),

    FAC_BUILDN_SHLUND("FAC/BUILDN/SHLUND"),

    FAC_BUILDN_SHOP("FAC/BUILDN/SHOP"),

    FAC_BUILDN_TOW("FAC/BUILDN/TOW"),

    FAC_BUILDN_TUN("FAC/BUILDN/TUN"),

    FAC_BUILDN_WALL("FAC/BUILDN/WALL"),

    FAC_BUILDN_WTW("FAC/BUILDN/WTW"),

    FAC_DEPOT_BIO("FAC/DEPOT/BIO"),

    FAC_DEPOT_CBRN("FAC/DEPOT/CBRN"),

    FAC_DEPOT_CHM("FAC/DEPOT/CHM"),

    FAC_DEPOT_ENG("FAC/DEPOT/ENG"),

    FAC_DEPOT_MED("FAC/DEPOT/MED"),

    FAC_DEPOT_MUN("FAC/DEPOT/MUN"),

    FAC_DEPOT_POL("FAC/DEPOT/POL"),

    FAC_NETWK_ADSL("FAC/NETWK/ADSL"),

    FAC_NETWK_ATM("FAC/NETWK/ATM"),

    FAC_NETWK_CTZALT("FAC/NETWK/CTZALT"),

    FAC_NETWK_EMGNWK("FAC/NETWK/EMGNWK"),

    FAC_NETWK_GPRS("FAC/NETWK/GPRS"),

    FAC_NETWK_GSM("FAC/NETWK/GSM"),

    FAC_NETWK_INTRAN("FAC/NETWK/INTRAN"),

    FAC_NETWK_INTRNT("FAC/NETWK/INTRNT"),

    FAC_NETWK_ISDN("FAC/NETWK/ISDN"),

    FAC_NETWK_LAN("FAC/NETWK/LAN"),

    FAC_NETWK_PAMR("FAC/NETWK/PAMR"),

    FAC_NETWK_PDMR("FAC/NETWK/PDMR"),

    FAC_NETWK_PGSM("FAC/NETWK/PGSM"),

    FAC_NETWK_PSTN("FAC/NETWK/PSTN"),

    FAC_NETWK_RADEHF("FAC/NETWK/RADEHF"),

    FAC_NETWK_RADHF("FAC/NETWK/RADHF"),

    FAC_NETWK_RADIO("FAC/NETWK/RADIO"),

    FAC_NETWK_RADLF("FAC/NETWK/RADLF"),

    FAC_NETWK_RADMF("FAC/NETWK/RADMF"),

    FAC_NETWK_RADSHF("FAC/NETWK/RADSHF"),

    FAC_NETWK_RADUHF("FAC/NETWK/RADUHF"),

    FAC_NETWK_RADVHF("FAC/NETWK/RADVHF"),

    FAC_NETWK_RADVLF("FAC/NETWK/RADVLF"),

    FAC_NETWK_RAYNET("FAC/NETWK/RAYNET"),

    FAC_NETWK_RELAY("FAC/NETWK/RELAY"),

    FAC_NETWK_SDSL("FAC/NETWK/SDSL"),

    FAC_NETWK_TV("FAC/NETWK/TV"),

    FAC_NETWK_UMTS("FAC/NETWK/UMTS"),

    FAC_NETWK_VDSL("FAC/NETWK/VDSL"),

    FAC_NETWK_WAN("FAC/NETWK/WAN"),

    FAC_NETWK_WIMAX("FAC/NETWK/WIMAX"),

    FAC_NETWK_WLAN("FAC/NETWK/WLAN"),

    FAC_OPR_AMBFAC("FAC/OPR/AMBFAC"),

    FAC_OPR_BDHOLD("FAC/OPR/BDHOLD"),

    FAC_OPR_CAMP("FAC/OPR/CAMP"),

    FAC_OPR_CASBUR("FAC/OPR/CASBUR"),

    FAC_OPR_CASCLR("FAC/OPR/CASCLR"),

    FAC_OPR_CASCOL("FAC/OPR/CASCOL"),

    FAC_OPR_CP("FAC/OPR/CP"),

    FAC_OPR_CSCLPT("FAC/OPR/CSCLPT"),

    FAC_OPR_CVCLPT("FAC/OPR/CVCLPT"),

    FAC_OPR_DEBRDP("FAC/OPR/DEBRDP"),

    FAC_OPR_DECONP("FAC/OPR/DECONP"),

    FAC_OPR_DISBED("FAC/OPR/DISBED"),

    FAC_OPR_DOCFAC("FAC/OPR/DOCFAC"),

    FAC_OPR_EMMORT("FAC/OPR/EMMORT"),

    FAC_OPR_EQPOOL("FAC/OPR/EQPOOL"),

    FAC_OPR_EVASSP("FAC/OPR/EVASSP"),

    FAC_OPR_FACAIR("FAC/OPR/FACAIR"),

    FAC_OPR_FACMIL("FAC/OPR/FACMIL"),

    FAC_OPR_FACNAV("FAC/OPR/FACNAV"),

    FAC_OPR_FAMFRD("FAC/OPR/FAMFRD"),

    FAC_OPR_FIRFAC("FAC/OPR/FIRFAC"),

    FAC_OPR_FSAAMM("FAC/OPR/FSAAMM"),

    FAC_OPR_GERBED("FAC/OPR/GERBED"),

    FAC_OPR_HOLD("FAC/OPR/HOLD"),

    FAC_OPR_HPD("FAC/OPR/HPD"),

    FAC_OPR_HPT("FAC/OPR/HPT"),

    FAC_OPR_HSP("FAC/OPR/HSP"),

    FAC_OPR_HSPFLD("FAC/OPR/HSPFLD"),

    FAC_OPR_HSPFLD2("FAC/OPR/HSPFLD"),

    FAC_OPR_IRM("FAC/OPR/IRM"),

    FAC_OPR_MARSHAL("FAC/OPR/MARSHAL"),

    FAC_OPR_MATBED("FAC/OPR/MATBED"),

    FAC_OPR_MEDBED("FAC/OPR/MEDBED"),

    FAC_OPR_MEDSPT("FAC/OPR/MEDSPT"),

    FAC_OPR_MOBLCP("FAC/OPR/MOBLCP"),

    FAC_OPR_OPCTCN("FAC/OPR/OPCTCN"),

    FAC_OPR_PHARMA("FAC/OPR/PHARMA"),

    FAC_OPR_POLFAC("FAC/OPR/POLFAC"),

    FAC_OPR_POLPT("FAC/OPR/POLPT"),

    FAC_OPR_REFARE("FAC/OPR/REFARE"),

    FAC_OPR_RRRSPT("FAC/OPR/RRRSPT"),

    FAC_OPR_SITLOG("FAC/OPR/SITLOG"),

    FAC_OPR_SPTARE("FAC/OPR/SPTARE"),

    FAC_OPR_SRVCNT("FAC/OPR/SRVCNT"),

    FAC_OPR_STCOCN("FAC/OPR/STCOCN"),

    FAC_OPR_STCTCN("FAC/OPR/STCTCN"),

    FAC_OPR_TCCTCN("FAC/OPR/TCCTCN"),

    FAC_OTH_ACCOM("FAC/OTH/ACCOM"),

    FAC_OTH_AIRFLD("FAC/OTH/AIRFLD"),

    FAC_OTH_BANK("FAC/OTH/BANK"),

    FAC_OTH_BATH("FAC/OTH/BATH"),

    FAC_OTH_CAN("FAC/OTH/CAN"),

    FAC_OTH_CEM("FAC/OTH/CEM"),

    FAC_OTH_DCH("FAC/OTH/DCH"),

    FAC_OTH_ELCINS("FAC/OTH/ELCINS"),

    FAC_OTH_ELCSPL("FAC/OTH/ELCSPL"),

    FAC_OTH_EQIMFT("FAC/OTH/EQIMFT"),

    FAC_OTH_FACGOV("FAC/OTH/FACGOV"),

    FAC_OTH_FACPOW("FAC/OTH/FACPOW"),

    FAC_OTH_FACTEC("FAC/OTH/FACTEC"),

    FAC_OTH_FACTEL("FAC/OTH/FACTEL"),

    FAC_OTH_FACTRN("FAC/OTH/FACTRN"),

    FAC_OTH_FATST("FAC/OTH/FATST"),

    FAC_OTH_FERINS("FAC/OTH/FERINS"),

    FAC_OTH_FHPT("FAC/OTH/FHPT"),

    FAC_OTH_LGRLPT("FAC/OTH/LGRLPT"),

    FAC_OTH_MAINTF("FAC/OTH/MAINTF"),

    FAC_OTH_PTL("FAC/OTH/PTL"),

    FAC_OTH_RES("FAC/OTH/RES"),

    FAC_OTH_VST("FAC/OTH/VST"),

    FAC_OTH_WATSPL("FAC/OTH/WATSPL"),

    FAC_OTH_WSHFAC("FAC/OTH/WSHFAC"),

    FAC_WATFIR_FOMBLK("FAC/WATFIR/FOMBLK"),

    FAC_WATFIR_HYDRNT("FAC/WATFIR/HYDRNT"),

    FAC_WATFIR_TOWNMN("FAC/WATFIR/TOWNMN"),

    HUM_CAPAB("HUM/CAPAB"),

    HUM_PERSON("HUM/PERSON"),

    HUM_UNIT("HUM/UNIT"),

    HUM_CAPAB_AMB("HUM/CAPAB/AMB"),

    HUM_CAPAB_FIR("HUM/CAPAB/FIR"),

    HUM_CAPAB_MED("HUM/CAPAB/MED"),

    HUM_CAPAB_MIL("HUM/CAPAB/MIL"),

    HUM_CAPAB_POL("HUM/CAPAB/POL"),

    HUM_CAPAB_TRP("HUM/CAPAB/TRP"),

    HUM_CAPAB_AMB_INCOFF("HUM/CAPAB/AMB/INCOFF"),

    HUM_CAPAB_AMB_PARAMD("HUM/CAPAB/AMB/PARAMD"),

    HUM_CAPAB_AMB_SAFOFF("HUM/CAPAB/AMB/SAFOFF"),

    HUM_CAPAB_AMB_TECHNIC("HUM/CAPAB/AMB/TECHNIC"),

    HUM_CAPAB_FIR_BACOFF("HUM/CAPAB/FIR/BACOFF"),

    HUM_CAPAB_FIR_BAEOFF("HUM/CAPAB/FIR/BAEOFF"),

    HUM_CAPAB_FIR_COMOFF("HUM/CAPAB/FIR/COMOFF"),

    HUM_CAPAB_FIR_CONOFF("HUM/CAPAB/FIR/CONOFF"),

    HUM_CAPAB_FIR_DECOFF("HUM/CAPAB/FIR/DECOFF"),

    HUM_CAPAB_FIR_FINOFF("HUM/CAPAB/FIR/FINOFF"),

    HUM_CAPAB_FIR_FOMOFF("HUM/CAPAB/FIR/FOMOFF"),

    HUM_CAPAB_FIR_HAZOFF("HUM/CAPAB/FIR/HAZOFF"),

    HUM_CAPAB_FIR_INCCOM("HUM/CAPAB/FIR/INCCOM"),

    HUM_CAPAB_FIR_LIAOFF("HUM/CAPAB/FIR/LIAOFF"),

    HUM_CAPAB_FIR_LOGOFF("HUM/CAPAB/FIR/LOGOFF"),

    HUM_CAPAB_FIR_MAROFF("HUM/CAPAB/FIR/MAROFF"),

    HUM_CAPAB_FIR_MEDOFF("HUM/CAPAB/FIR/MEDOFF"),

    HUM_CAPAB_FIR_OPRCOM("HUM/CAPAB/FIR/OPRCOM"),

    HUM_CAPAB_FIR_SAFOFF("HUM/CAPAB/FIR/SAFOFF"),

    HUM_CAPAB_FIR_SALOFF("HUM/CAPAB/FIR/SALOFF"),

    HUM_CAPAB_FIR_SECCOM("HUM/CAPAB/FIR/SECCOM"),

    HUM_CAPAB_FIR_STAOFF("HUM/CAPAB/FIR/STAOFF"),

    HUM_CAPAB_FIR_STRCOM("HUM/CAPAB/FIR/STRCOM"),

    HUM_CAPAB_FIR_TACCOM("HUM/CAPAB/FIR/TACCOM"),

    HUM_CAPAB_FIR_WATOFF("HUM/CAPAB/FIR/WATOFF"),

    HUM_CAPAB_MED_ANSPHY("HUM/CAPAB/MED/ANSPHY"),

    HUM_CAPAB_MED_DNTPHY("HUM/CAPAB/MED/DNTPHY"),

    HUM_CAPAB_MED_DOCTOR("HUM/CAPAB/MED/DOCTOR"),

    HUM_CAPAB_MED_GYNPHY("HUM/CAPAB/MED/GYNPHY"),

    HUM_CAPAB_MED_HDNPHY("HUM/CAPAB/MED/HDNPHY"),

    HUM_CAPAB_MED_INMPHY("HUM/CAPAB/MED/INMPHY"),

    HUM_CAPAB_MED_NURSE("HUM/CAPAB/MED/NURSE"),

    HUM_CAPAB_MED_ORTPHY("HUM/CAPAB/MED/ORTPHY"),

    HUM_CAPAB_MED_OTHPHY("HUM/CAPAB/MED/OTHPHY"),

    HUM_CAPAB_MED_PRCPHY("HUM/CAPAB/MED/PRCPHY"),

    HUM_CAPAB_MED_PSYPHY("HUM/CAPAB/MED/PSYPHY"),

    HUM_CAPAB_MED_PTHPHY("HUM/CAPAB/MED/PTHPHY"),

    HUM_CAPAB_MED_RADPHY("HUM/CAPAB/MED/RADPHY"),

    HUM_CAPAB_MED_SURPHY("HUM/CAPAB/MED/SURPHY"),

    HUM_CAPAB_MIL_AUTCDR("HUM/CAPAB/MIL/AUTCDR"),

    HUM_CAPAB_MIL_INTOFF("HUM/CAPAB/MIL/INTOFF"),

    HUM_CAPAB_MIL_LIAISN("HUM/CAPAB/MIL/LIAISN"),

    HUM_CAPAB_MIL_OF1("HUM/CAPAB/MIL/OF1"),

    HUM_CAPAB_MIL_OF10("HUM/CAPAB/MIL/OF10"),

    HUM_CAPAB_MIL_OF2("HUM/CAPAB/MIL/OF2"),

    HUM_CAPAB_MIL_OF3("HUM/CAPAB/MIL/OF3"),

    HUM_CAPAB_MIL_OF4("HUM/CAPAB/MIL/OF4"),

    HUM_CAPAB_MIL_OF5("HUM/CAPAB/MIL/OF5"),

    HUM_CAPAB_MIL_OF6("HUM/CAPAB/MIL/OF6"),

    HUM_CAPAB_MIL_OF7("HUM/CAPAB/MIL/OF7"),

    HUM_CAPAB_MIL_OF8("HUM/CAPAB/MIL/OF8"),

    HUM_CAPAB_MIL_OF9("HUM/CAPAB/MIL/OF9"),

    HUM_CAPAB_MIL_OFFR("HUM/CAPAB/MIL/OFFR"),

    HUM_CAPAB_MIL_OPSOFF("HUM/CAPAB/MIL/OPSOFF"),

    HUM_CAPAB_MIL_OR1("HUM/CAPAB/MIL/OR1"),

    HUM_CAPAB_MIL_OR2("HUM/CAPAB/MIL/OR2"),

    HUM_CAPAB_MIL_OR3("HUM/CAPAB/MIL/OR3"),

    HUM_CAPAB_MIL_OR4("HUM/CAPAB/MIL/OR4"),

    HUM_CAPAB_MIL_OR5("HUM/CAPAB/MIL/OR5"),

    HUM_CAPAB_MIL_OR6("HUM/CAPAB/MIL/OR6"),

    HUM_CAPAB_MIL_OR7("HUM/CAPAB/MIL/OR7"),

    HUM_CAPAB_MIL_OR8("HUM/CAPAB/MIL/OR8"),

    HUM_CAPAB_MIL_OR9("HUM/CAPAB/MIL/OR9"),

    HUM_CAPAB_MIL_OTHR("HUM/CAPAB/MIL/OTHR"),

    HUM_CAPAB_MIL_POC("HUM/CAPAB/MIL/POC"),

    HUM_CAPAB_POL_BMBOFF("HUM/CAPAB/POL/BMBOFF"),

    HUM_CAPAB_POL_CASOFF("HUM/CAPAB/POL/CASOFF"),

    HUM_CAPAB_POL_COFF("HUM/CAPAB/POL/COFF"),

    HUM_CAPAB_POL_DETCTV("HUM/CAPAB/POL/DETCTV"),

    HUM_CAPAB_POL_DIVER("HUM/CAPAB/POL/DIVER"),

    HUM_CAPAB_POL_MOM("HUM/CAPAB/POL/MOM"),

    HUM_CAPAB_POL_PIO("HUM/CAPAB/POL/PIO"),

    HUM_CAPAB_POL_PMR("HUM/CAPAB/POL/PMR"),

    HUM_CAPAB_POL_RDINV("HUM/CAPAB/POL/RDINV"),

    HUM_CAPAB_POL_SCO("HUM/CAPAB/POL/SCO"),

    HUM_CAPAB_POL_SIO("HUM/CAPAB/POL/SIO"),

    HUM_CAPAB_POL_STTTK("HUM/CAPAB/POL/STTTK"),

    HUM_CAPAB_TRP_AIRFW("HUM/CAPAB/TRP/AIRFW"),

    HUM_CAPAB_TRP_AIRRW("HUM/CAPAB/TRP/AIRRW"),

    HUM_CAPAB_TRP_AMPH("HUM/CAPAB/TRP/AMPH"),

    HUM_CAPAB_TRP_LNDRAI("HUM/CAPAB/TRP/LNDRAI"),

    HUM_CAPAB_TRP_LNDWHL("HUM/CAPAB/TRP/LNDWHL"),

    HUM_CAPAB_TRP_SEASS("HUM/CAPAB/TRP/SEASS"),

    HUM_CAPAB_TRP_SEASUR("HUM/CAPAB/TRP/SEASUR"),

    HUM_PERSON_CFIROF("HUM/PERSON/CFIROF"),

    HUM_PERSON_GOVEMP("HUM/PERSON/GOVEMP"),

    HUM_PERSON_INTLCT("HUM/PERSON/INTLCT"),

    HUM_PERSON_JRNLST("HUM/PERSON/JRNLST"),

    HUM_PERSON_MEDIA("HUM/PERSON/MEDIA"),

    HUM_PERSON_NONGVE("HUM/PERSON/NONGVE"),

    HUM_PERSON_POLCHF("HUM/PERSON/POLCHF"),

    HUM_PERSON_VILELD("HUM/PERSON/VILELD"),

    HUM_PERSON_WRITER("HUM/PERSON/WRITER"),

    HUM_UNIT_AIRLSN("HUM/UNIT/AIRLSN"),

    HUM_UNIT_C2("HUM/UNIT/C2"),

    HUM_UNIT_CBRN("HUM/UNIT/CBRN"),

    HUM_UNIT_CONST("HUM/UNIT/CONST"),

    HUM_UNIT_CRSMAN("HUM/UNIT/CRSMAN"),

    HUM_UNIT_DISID("HUM/UNIT/DISID"),

    HUM_UNIT_EMPOFF("HUM/UNIT/EMPOFF"),

    HUM_UNIT_ENG("HUM/UNIT/ENG"),

    HUM_UNIT_ENVOFF("HUM/UNIT/ENVOFF"),

    HUM_UNIT_FINANC("HUM/UNIT/FINANC"),

    HUM_UNIT_FIXWNG("HUM/UNIT/FIXWNG"),

    HUM_UNIT_GUID("HUM/UNIT/GUID"),

    HUM_UNIT_HELCTR("HUM/UNIT/HELCTR"),

    HUM_UNIT_LAWENF("HUM/UNIT/LAWENF"),

    HUM_UNIT_LNDSPT("HUM/UNIT/LNDSPT"),

    HUM_UNIT_LOG("HUM/UNIT/LOG"),

    HUM_UNIT_MAGRSP("HUM/UNIT/MAGRSP"),

    HUM_UNIT_MAINT("HUM/UNIT/MAINT"),

    HUM_UNIT_MDSADV("HUM/UNIT/MDSADV"),

    HUM_UNIT_MEDCL("HUM/UNIT/MEDCL"),

    HUM_UNIT_MST("HUM/UNIT/MST"),

    HUM_UNIT_MSURTM("HUM/UNIT/MSURTM"),

    HUM_UNIT_NAVAL("HUM/UNIT/NAVAL"),

    HUM_UNIT_POL("HUM/UNIT/POL"),

    HUM_UNIT_PSYCH("HUM/UNIT/PSYCH"),

    HUM_UNIT_RAILWY("HUM/UNIT/RAILWY"),

    HUM_UNIT_RECCE("HUM/UNIT/RECCE"),

    HUM_UNIT_RELCHP("HUM/UNIT/RELCHP"),

    HUM_UNIT_RIVERN("HUM/UNIT/RIVERN"),

    HUM_UNIT_SAR("HUM/UNIT/SAR"),

    HUM_UNIT_SECPOL("HUM/UNIT/SECPOL"),

    HUM_UNIT_SHRPAT("HUM/UNIT/SHRPAT"),

    HUM_UNIT_SPECIA("HUM/UNIT/SPECIA"),

    HUM_UNIT_SURG("HUM/UNIT/SURG"),

    HUM_UNIT_TRAUMA("HUM/UNIT/TRAUMA"),

    HUM_UNIT_TRNPTN("HUM/UNIT/TRNPTN"),

    HUM_UNIT_VET("HUM/UNIT/VET"),

    HUM_UNIT_WLFCOR("HUM/UNIT/WLFCOR"),

    HUM_UNIT_POL_AIRSPT("HUM/UNIT/POL/AIRSPT"),

    HUM_UNIT_POL_MNTPOL("HUM/UNIT/POL/MNTPOL"),

    HUM_UNIT_POL_PUBORD("HUM/UNIT/POL/PUBORD"),

    HUM_UNIT_POL_RDSPT("HUM/UNIT/POL/RDSPT"),

    HUM_UNIT_POL_SPCLST("HUM/UNIT/POL/SPCLST"),

    HUM_UNIT_SAR_CSAR("HUM/UNIT/SAR/CSAR"),

    HUM_UNIT_SAR_MSAR("HUM/UNIT/SAR/MSAR"),

    HUM_UNIT_SAR_RSAR("HUM/UNIT/SAR/RSAR"),

    HUM_UNIT_SAR_RST("HUM/UNIT/SAR/RST"),

    HUM_UNIT_SAR_SSAR("HUM/UNIT/SAR/SSAR"),

    HUM_UNIT_SAR_USAR("HUM/UNIT/SAR/USAR"),

    HUM_UNIT_SAR_WSAR("HUM/UNIT/SAR/WSAR"),

    HUM_UNIT_SAR_USAR_CANIN("HUM/UNIT/SAR/USAR/CANIN"),

    HUM_UNIT_SAR_USAR_DETEC("HUM/UNIT/SAR/USAR/DETEC"),

    MAT_CM("MAT/CM"),

    MAT_EQ("MAT/EQ"),

    MAT_VEH("MAT/VEH"),

    MAT_CM_ABSAG("MAT/CM/ABSAG"),

    MAT_CM_BIOAGN("MAT/CM/BIOAGN"),

    MAT_CM_CHMAGN("MAT/CM/CHMAGN"),

    MAT_CM_CON("MAT/CM/CON"),

    MAT_CM_EXTAG("MAT/CM/EXTAG"),

    MAT_CM_FOO("MAT/CM/FOO"),

    MAT_CM_FUEL("MAT/CM/FUEL"),

    MAT_CM_FUSE("MAT/CM/FUSE"),

    MAT_CM_LUBRIC("MAT/CM/LUBRIC"),

    MAT_CM_MATING("MAT/CM/MATING"),

    MAT_CM_MEDICN("MAT/CM/MEDICN"),

    MAT_CM_MEDSPL("MAT/CM/MEDSPL"),

    MAT_CM_MEGPHN("MAT/CM/MEGPHN"),

    MAT_CM_MONEY("MAT/CM/MONEY"),

    MAT_CM_OIL("MAT/CM/OIL"),

    MAT_CM_PAINT("MAT/CM/PAINT"),

    MAT_CM_PAPER("MAT/CM/PAPER"),

    MAT_CM_PPE("MAT/CM/PPE"),

    MAT_CM_RATCO("MAT/CM/RATCO"),

    MAT_CM_RATFR("MAT/CM/RATFR"),

    MAT_CM_RATTI("MAT/CM/RATTI"),

    MAT_CM_RETAG("MAT/CM/RETAG"),

    MAT_CM_TIMBER("MAT/CM/TIMBER"),

    MAT_CM_UNIFRM("MAT/CM/UNIFRM"),

    MAT_CM_WIRE("MAT/CM/WIRE"),

    MAT_CM_WTREXT("MAT/CM/WTREXT"),

    MAT_CM_WTRPOT("MAT/CM/WTRPOT"),

    MAT_CM_ABSAG_CHM("MAT/CM/ABSAG/CHM"),

    MAT_CM_ABSAG_PHY("MAT/CM/ABSAG/PHY"),

    MAT_CM_EXTAG_CO2("MAT/CM/EXTAG/CO2"),

    MAT_CM_EXTAG_DRYMIN("MAT/CM/EXTAG/DRYMIN"),

    MAT_CM_EXTAG_FATFIR("MAT/CM/EXTAG/FATFIR"),

    MAT_CM_EXTAG_FOAM("MAT/CM/EXTAG/FOAM"),

    MAT_CM_EXTAG_HALON("MAT/CM/EXTAG/HALON"),

    MAT_CM_EXTAG_INERT("MAT/CM/EXTAG/INERT"),

    MAT_CM_EXTAG_METPWD("MAT/CM/EXTAG/METPWD"),

    MAT_CM_EXTAG_POWDER("MAT/CM/EXTAG/POWDER"),

    MAT_CM_EXTAG_FOAM_AFFF("MAT/CM/EXTAG/FOAM/AFFF"),

    MAT_CM_EXTAG_FOAM_AFFFAR("MAT/CM/EXTAG/FOAM/AFFFAR"),

    MAT_CM_EXTAG_FOAM_OTH("MAT/CM/EXTAG/FOAM/OTH"),

    MAT_CM_FUEL_AVNFU("MAT/CM/FUEL/AVNFU"),

    MAT_CM_FUEL_DIESEL("MAT/CM/FUEL/DIESEL"),

    MAT_CM_FUEL_KEROS("MAT/CM/FUEL/KEROS"),

    MAT_CM_FUEL_LPG("MAT/CM/FUEL/LPG"),

    MAT_CM_FUEL_NATGAS("MAT/CM/FUEL/NATGAS"),

    MAT_CM_FUEL_PETROL("MAT/CM/FUEL/PETROL"),

    MAT_CM_MEDICN_1STAID("MAT/CM/MEDICN/1STAID"),

    MAT_CM_MEDICN_AMPHTM("MAT/CM/MEDICN/AMPHTM"),

    MAT_CM_MEDICN_BLOOD("MAT/CM/MEDICN/BLOOD"),

    MAT_CM_MEDICN_BNDDR("MAT/CM/MEDICN/BNDDR"),

    MAT_CM_MEDICN_KTMINE("MAT/CM/MEDICN/KTMINE"),

    MAT_CM_MEDICN_MORFIN("MAT/CM/MEDICN/MORFIN"),

    MAT_CM_MEDICN_WTRMED("MAT/CM/MEDICN/WTRMED"),

    MAT_CM_PPE_CBRNKIT("MAT/CM/PPE/CBRNKIT"),

    MAT_CM_PPE_CLOTH("MAT/CM/PPE/CLOTH"),

    MAT_CM_PPE_RESP("MAT/CM/PPE/RESP"),

    MAT_CM_PPE_SURCOT("MAT/CM/PPE/SURCOT"),

    MAT_CM_PPE_CLOTH_CHEMCL("MAT/CM/PPE/CLOTH/CHEMCL"),

    MAT_CM_PPE_CLOTH_FFCLO("MAT/CM/PPE/CLOTH/FFCLO"),

    MAT_CM_PPE_CLOTH_FKIT("MAT/CM/PPE/CLOTH/FKIT"),

    MAT_CM_PPE_CLOTH_CHEMCL_CHEMB("MAT/CM/PPE/CLOTH/CHEMCL/CHEMB"),

    MAT_CM_PPE_CLOTH_CHEMCL_CHEMG("MAT/CM/PPE/CLOTH/CHEMCL/CHEMG"),

    MAT_CM_PPE_CLOTH_CHEMCL_GASSU("MAT/CM/PPE/CLOTH/CHEMCL/GASSU"),

    MAT_CM_PPE_CLOTH_CHEMCL_LIQSU("MAT/CM/PPE/CLOTH/CHEMCL/LIQSU"),

    MAT_CM_PPE_CLOTH_CHEMCL_SPLASU("MAT/CM/PPE/CLOTH/CHEMCL/SPLASU"),

    MAT_CM_PPE_CLOTH_CHEMCL_TEMPSU("MAT/CM/PPE/CLOTH/CHEMCL/TEMPSU"),

    MAT_EQ_CBRN("MAT/EQ/CBRN"),

    MAT_EQ_ELC("MAT/EQ/ELC"),

    MAT_EQ_ENG("MAT/EQ/ENG"),

    MAT_EQ_OTH("MAT/EQ/OTH"),

    MAT_EQ_POLICE("MAT/EQ/POLICE"),

    MAT_EQ_CBRN_ABICHM("MAT/EQ/CBRN/ABICHM"),

    MAT_EQ_CBRN_ABIDET("MAT/EQ/CBRN/ABIDET"),

    MAT_EQ_CBRN_ACHDET("MAT/EQ/CBRN/ACHDET"),

    MAT_EQ_CBRN_ARDDET("MAT/EQ/CBRN/ARDDET"),

    MAT_EQ_CBRN_BIOINT("MAT/EQ/CBRN/BIOINT"),

    MAT_EQ_CBRN_BIOSTO("MAT/EQ/CBRN/BIOSTO"),

    MAT_EQ_CBRN_CBRNDEC("MAT/EQ/CBRN/CBRNDEC"),

    MAT_EQ_CBRN_CBRNREC("MAT/EQ/CBRN/CBRNREC"),

    MAT_EQ_CBRN_CHMMON("MAT/EQ/CBRN/CHMMON"),

    MAT_EQ_CBRN_MSSPTR("MAT/EQ/CBRN/MSSPTR"),

    MAT_EQ_CBRN_RDSPTR("MAT/EQ/CBRN/RDSPTR"),

    MAT_EQ_ELC_AMTRAD("MAT/EQ/ELC/AMTRAD"),

    MAT_EQ_ELC_C3I("MAT/EQ/ELC/C3I"),

    MAT_EQ_ELC_COMSYS("MAT/EQ/ELC/COMSYS"),

    MAT_EQ_ELC_COMVEH("MAT/EQ/ELC/COMVEH"),

    MAT_EQ_ELC_MULTIRE("MAT/EQ/ELC/MULTIRE"),

    MAT_EQ_ELC_NAV("MAT/EQ/ELC/NAV"),

    MAT_EQ_ELC_NAVRAD("MAT/EQ/ELC/NAVRAD"),

    MAT_EQ_ELC_OTH("MAT/EQ/ELC/OTH"),

    MAT_EQ_ELC_POWGN("MAT/EQ/ELC/POWGN"),

    MAT_EQ_ELC_RIDD("MAT/EQ/ELC/RIDD"),

    MAT_EQ_ELC_SEN("MAT/EQ/ELC/SEN"),

    MAT_EQ_ELC_SONAR("MAT/EQ/ELC/SONAR"),

    MAT_EQ_ELC_THIMC("MAT/EQ/ELC/THIMC"),

    MAT_EQ_ELC_VIBRA("MAT/EQ/ELC/VIBRA"),

    MAT_EQ_ELC_COMSYS_MEGPHN("MAT/EQ/ELC/COMSYS/MEGPHN"),

    MAT_EQ_ELC_COMSYS_PAGER("MAT/EQ/ELC/COMSYS/PAGER"),

    MAT_EQ_ELC_COMSYS_PMRRDIO("MAT/EQ/ELC/COMSYS/PMRRDIO"),

    MAT_EQ_ELC_COMSYS_PUBADD("MAT/EQ/ELC/COMSYS/PUBADD"),

    MAT_EQ_ELC_COMSYS_RDBRCT("MAT/EQ/ELC/COMSYS/RDBRCT"),

    MAT_EQ_ENG_BRIDGG("MAT/EQ/ENG/BRIDGG"),

    MAT_EQ_ENG_CNSTVE("MAT/EQ/ENG/CNSTVE"),

    MAT_EQ_ENG_CONST("MAT/EQ/ENG/CONST"),

    MAT_EQ_ENG_DOZER("MAT/EQ/ENG/DOZER"),

    MAT_EQ_ENG_ERTHMV("MAT/EQ/ENG/ERTHMV"),

    MAT_EQ_ENG_FIRFGT("MAT/EQ/ENG/FIRFGT"),

    MAT_EQ_ENG_INTEL("MAT/EQ/ENG/INTEL"),

    MAT_EQ_ENG_MINECL("MAT/EQ/ENG/MINECL"),

    MAT_EQ_ENG_MINEDT("MAT/EQ/ENG/MINEDT"),

    MAT_EQ_ENG_MINEMR("MAT/EQ/ENG/MINEMR"),

    MAT_EQ_ENG_WPNPRT("MAT/EQ/ENG/WPNPRT"),

    MAT_EQ_ENG_FIRFGT_BRHTAP("MAT/EQ/ENG/FIRFGT/BRHTAP"),

    MAT_EQ_ENG_FIRFGT_CEAR("MAT/EQ/ENG/FIRFGT/CEAR"),

    MAT_EQ_ENG_FIRFGT_CEC("MAT/EQ/ENG/FIRFGT/CEC"),

    MAT_EQ_ENG_FIRFGT_CECH("MAT/EQ/ENG/FIRFGT/CECH"),

    MAT_EQ_ENG_FIRFGT_CEEV("MAT/EQ/ENG/FIRFGT/CEEV"),

    MAT_EQ_ENG_FIRFGT_CEM("MAT/EQ/ENG/FIRFGT/CEM"),

    MAT_EQ_ENG_FIRFGT_CEPC("MAT/EQ/ENG/FIRFGT/CEPC"),

    MAT_EQ_ENG_FIRFGT_CEPO("MAT/EQ/ENG/FIRFGT/CEPO"),

    MAT_EQ_ENG_FIRFGT_CEPOL("MAT/EQ/ENG/FIRFGT/CEPOL"),

    MAT_EQ_ENG_FIRFGT_CER("MAT/EQ/ENG/FIRFGT/CER"),

    MAT_EQ_ENG_FIRFGT_CESD("MAT/EQ/ENG/FIRFGT/CESD"),

    MAT_EQ_ENG_FIRFGT_GRDMON("MAT/EQ/ENG/FIRFGT/GRDMON"),

    MAT_EQ_ENG_FIRFGT_MPR("MAT/EQ/ENG/FIRFGT/MPR"),

    MAT_EQ_ENG_FIRFGT_RAR("MAT/EQ/ENG/FIRFGT/RAR"),

    MAT_EQ_ENG_FIRFGT_UMIR("MAT/EQ/ENG/FIRFGT/UMIR"),

    MAT_EQ_ENG_FIRFGT_VAMUR("MAT/EQ/ENG/FIRFGT/VAMUR"),

    MAT_EQ_ENG_INTEL_CAMERA("MAT/EQ/ENG/INTEL/CAMERA"),

    MAT_EQ_ENG_INTEL_CCTVCM("MAT/EQ/ENG/INTEL/CCTVCM"),

    MAT_EQ_ENG_INTEL_CDVDOG("MAT/EQ/ENG/INTEL/CDVDOG"),

    MAT_EQ_ENG_INTEL_FSPDCM("MAT/EQ/ENG/INTEL/FSPDCM"),

    MAT_EQ_ENG_INTEL_FTFLCM("MAT/EQ/ENG/INTEL/FTFLCM"),

    MAT_EQ_ENG_INTEL_PSPDCM("MAT/EQ/ENG/INTEL/PSPDCM"),

    MAT_EQ_ENG_INTEL_TCKDOG("MAT/EQ/ENG/INTEL/TCKDOG"),

    MAT_EQ_ENG_WPNPRT_BALVST("MAT/EQ/ENG/WPNPRT/BALVST"),

    MAT_EQ_ENG_WPNPRT_BATON("MAT/EQ/ENG/WPNPRT/BATON"),

    MAT_EQ_ENG_WPNPRT_ENFDOG("MAT/EQ/ENG/WPNPRT/ENFDOG"),

    MAT_EQ_ENG_WPNPRT_FIREARM("MAT/EQ/ENG/WPNPRT/FIREARM"),

    MAT_EQ_ENG_WPNPRT_HNDCUF("MAT/EQ/ENG/WPNPRT/HNDCUF"),

    MAT_EQ_ENG_WPNPRT_OFFPRT("MAT/EQ/ENG/WPNPRT/OFFPRT"),

    MAT_EQ_ENG_WPNPRT_PRSCNT("MAT/EQ/ENG/WPNPRT/PRSCNT"),

    MAT_EQ_OTH_BLNKT("MAT/EQ/OTH/BLNKT"),

    MAT_EQ_OTH_CONTNR("MAT/EQ/OTH/CONTNR"),

    MAT_EQ_OTH_CUTING("MAT/EQ/OTH/CUTING"),

    MAT_EQ_OTH_TANK("MAT/EQ/OTH/TANK"),

    MAT_EQ_OTH_TENT("MAT/EQ/OTH/TENT"),

    MAT_EQ_OTH_WATPUR("MAT/EQ/OTH/WATPUR"),

    MAT_EQ_POLICE_BRTEST("MAT/EQ/POLICE/BRTEST"),

    MAT_EQ_POLICE_CONE("MAT/EQ/POLICE/CONE"),

    MAT_EQ_POLICE_LAMP("MAT/EQ/POLICE/LAMP"),

    MAT_EQ_POLICE_STINGER("MAT/EQ/POLICE/STINGER"),

    MAT_EQ_POLICE_TORCH("MAT/EQ/POLICE/TORCH"),

    MAT_EQ_POLICE_UNFRMC("MAT/EQ/POLICE/UNFRMC"),

    MAT_EQ_POLICE_UNFRMN("MAT/EQ/POLICE/UNFRMN"),

    MAT_VEH_AIRCRF("MAT/VEH/AIRCRF"),

    MAT_VEH_HORSE("MAT/VEH/HORSE"),

    MAT_VEH_RAILVE("MAT/VEH/RAILVE"),

    MAT_VEH_ROADVE("MAT/VEH/ROADVE"),

    MAT_VEH_VESSEL("MAT/VEH/VESSEL"),

    MAT_VEH_AIRCRF_AIRTRS("MAT/VEH/AIRCRF/AIRTRS"),

    MAT_VEH_AIRCRF_CMDCTL("MAT/VEH/AIRCRF/CMDCTL"),

    MAT_VEH_AIRCRF_HEL("MAT/VEH/AIRCRF/HEL"),

    MAT_VEH_AIRCRF_HELCMD("MAT/VEH/AIRCRF/HELCMD"),

    MAT_VEH_AIRCRF_HELMED("MAT/VEH/AIRCRF/HELMED"),

    MAT_VEH_AIRCRF_HELREC("MAT/VEH/AIRCRF/HELREC"),

    MAT_VEH_AIRCRF_MEDEVC("MAT/VEH/AIRCRF/MEDEVC"),

    MAT_VEH_AIRCRF_PLANE("MAT/VEH/AIRCRF/PLANE"),

    MAT_VEH_AIRCRF_POLHEL("MAT/VEH/AIRCRF/POLHEL"),

    MAT_VEH_AIRCRF_RECCE("MAT/VEH/AIRCRF/RECCE"),

    MAT_VEH_AIRCRF_SAR("MAT/VEH/AIRCRF/SAR"),

    MAT_VEH_AIRCRF_TANKER("MAT/VEH/AIRCRF/TANKER"),

    MAT_VEH_AIRCRF_UAV("MAT/VEH/AIRCRF/UAV"),

    MAT_VEH_RAILVE_LCMDSE("MAT/VEH/RAILVE/LCMDSE"),

    MAT_VEH_RAILVE_LCMDSL("MAT/VEH/RAILVE/LCMDSL"),

    MAT_VEH_RAILVE_LCMELC("MAT/VEH/RAILVE/LCMELC"),

    MAT_VEH_RAILVE_LCMSTM("MAT/VEH/RAILVE/LCMSTM"),

    MAT_VEH_RAILVE_LCMTND("MAT/VEH/RAILVE/LCMTND"),

    MAT_VEH_RAILVE_LCMTVE("MAT/VEH/RAILVE/LCMTVE"),

    MAT_VEH_RAILVE_RLDEQP("MAT/VEH/RAILVE/RLDEQP"),

    MAT_VEH_RAILVE_RLLSTK("MAT/VEH/RAILVE/RLLSTK"),

    MAT_VEH_RAILVE_TRAM("MAT/VEH/RAILVE/TRAM"),

    MAT_VEH_RAILVE_WGNART("MAT/VEH/RAILVE/WGNART"),

    MAT_VEH_RAILVE_WGNBRK("MAT/VEH/RAILVE/WGNBRK"),

    MAT_VEH_RAILVE_WGNCAR("MAT/VEH/RAILVE/WGNCAR"),

    MAT_VEH_RAILVE_WGNCRG("MAT/VEH/RAILVE/WGNCRG"),

    MAT_VEH_RAILVE_WGNCSS("MAT/VEH/RAILVE/WGNCSS"),

    MAT_VEH_RAILVE_WGNCTL("MAT/VEH/RAILVE/WGNCTL"),

    MAT_VEH_RAILVE_WGNFLB("MAT/VEH/RAILVE/WGNFLB"),

    MAT_VEH_RAILVE_WGNFUL("MAT/VEH/RAILVE/WGNFUL"),

    MAT_VEH_RAILVE_WGNHPR("MAT/VEH/RAILVE/WGNHPR"),

    MAT_VEH_RAILVE_WGNISO("MAT/VEH/RAILVE/WGNISO"),

    MAT_VEH_RAILVE_WGNLQD("MAT/VEH/RAILVE/WGNLQD"),

    MAT_VEH_RAILVE_WGNMNR("MAT/VEH/RAILVE/WGNMNR"),

    MAT_VEH_RAILVE_WGNOPC("MAT/VEH/RAILVE/WGNOPC"),

    MAT_VEH_RAILVE_WGNPAS("MAT/VEH/RAILVE/WGNPAS"),

    MAT_VEH_RAILVE_WGNRFG("MAT/VEH/RAILVE/WGNRFG"),

    MAT_VEH_RAILVE_WGNRPR("MAT/VEH/RAILVE/WGNRPR"),

    MAT_VEH_RAILVE_WGNSPP("MAT/VEH/RAILVE/WGNSPP"),

    MAT_VEH_RAILVE_WGNWAT("MAT/VEH/RAILVE/WGNWAT"),

    MAT_VEH_RAILVE_WGNWFL("MAT/VEH/RAILVE/WGNWFL"),

    MAT_VEH_ROADVE_AMBUL("MAT/VEH/ROADVE/AMBUL"),

    MAT_VEH_ROADVE_AUTOMO("MAT/VEH/ROADVE/AUTOMO"),

    MAT_VEH_ROADVE_BICYCL("MAT/VEH/ROADVE/BICYCL"),

    MAT_VEH_ROADVE_BUS("MAT/VEH/ROADVE/BUS"),

    MAT_VEH_ROADVE_CCTRCK("MAT/VEH/ROADVE/CCTRCK"),

    MAT_VEH_ROADVE_CRANE("MAT/VEH/ROADVE/CRANE"),

    MAT_VEH_ROADVE_FRFGTN("MAT/VEH/ROADVE/FRFGTN"),

    MAT_VEH_ROADVE_HETVEH("MAT/VEH/ROADVE/HETVEH"),

    MAT_VEH_ROADVE_MAINT("MAT/VEH/ROADVE/MAINT"),

    MAT_VEH_ROADVE_MHVEH("MAT/VEH/ROADVE/MHVEH"),

    MAT_VEH_ROADVE_MILUV("MAT/VEH/ROADVE/MILUV"),

    MAT_VEH_ROADVE_MOTCYC("MAT/VEH/ROADVE/MOTCYC"),

    MAT_VEH_ROADVE_POD("MAT/VEH/ROADVE/POD"),

    MAT_VEH_ROADVE_POLICE("MAT/VEH/ROADVE/POLICE"),

    MAT_VEH_ROADVE_SEMI("MAT/VEH/ROADVE/SEMI"),

    MAT_VEH_ROADVE_TRACTR("MAT/VEH/ROADVE/TRACTR"),

    MAT_VEH_ROADVE_TRAILR("MAT/VEH/ROADVE/TRAILR"),

    MAT_VEH_ROADVE_TRLBUS("MAT/VEH/ROADVE/TRLBUS"),

    MAT_VEH_ROADVE_TRUCK("MAT/VEH/ROADVE/TRUCK"),

    MAT_VEH_ROADVE_FRFGTN_AERIAL("MAT/VEH/ROADVE/FRFGTN/AERIAL"),

    MAT_VEH_ROADVE_FRFGTN_BREATH("MAT/VEH/ROADVE/FRFGTN/BREATH"),

    MAT_VEH_ROADVE_FRFGTN_C3("MAT/VEH/ROADVE/FRFGTN/C3"),

    MAT_VEH_ROADVE_FRFGTN_FRF("MAT/VEH/ROADVE/FRFGTN/FRF"),

    MAT_VEH_ROADVE_FRFGTN_HAZMAT("MAT/VEH/ROADVE/FRFGTN/HAZMAT"),

    MAT_VEH_ROADVE_FRFGTN_OTHR("MAT/VEH/ROADVE/FRFGTN/OTHR"),

    MAT_VEH_ROADVE_FRFGTN_PERCAR("MAT/VEH/ROADVE/FRFGTN/PERCAR"),

    MAT_VEH_ROADVE_FRFGTN_PUMP("MAT/VEH/ROADVE/FRFGTN/PUMP"),

    MAT_VEH_ROADVE_FRFGTN_RSC("MAT/VEH/ROADVE/FRFGTN/RSC"),

    MAT_VEH_ROADVE_POLICE_COMLIA("MAT/VEH/ROADVE/POLICE/COMLIA"),

    MAT_VEH_ROADVE_POLICE_DOGUNT("MAT/VEH/ROADVE/POLICE/DOGUNT"),

    MAT_VEH_ROADVE_POLICE_GENPUR("MAT/VEH/ROADVE/POLICE/GENPUR"),

    MAT_VEH_ROADVE_POLICE_HAZMAT("MAT/VEH/ROADVE/POLICE/HAZMAT"),

    MAT_VEH_ROADVE_POLICE_MBIKE("MAT/VEH/ROADVE/POLICE/MBIKE"),

    MAT_VEH_ROADVE_POLICE_PATROL("MAT/VEH/ROADVE/POLICE/PATROL"),

    MAT_VEH_ROADVE_POLICE_RSPONSE("MAT/VEH/ROADVE/POLICE/RSPONSE"),

    MAT_VEH_ROADVE_POLICE_TRAFFIC("MAT/VEH/ROADVE/POLICE/TRAFFIC"),

    MAT_VEH_ROADVE_POLICE_TRANSIT("MAT/VEH/ROADVE/POLICE/TRANSIT"),

    MAT_VEH_ROADVE_POLICE_VAN("MAT/VEH/ROADVE/POLICE/VAN"),

    MAT_VEH_VESSEL_AIRCAR("MAT/VEH/VESSEL/AIRCAR"),

    MAT_VEH_VESSEL_AMPH("MAT/VEH/VESSEL/AMPH"),

    MAT_VEH_VESSEL_BARGE("MAT/VEH/VESSEL/BARGE"),

    MAT_VEH_VESSEL_BARSHP("MAT/VEH/VESSEL/BARSHP"),

    MAT_VEH_VESSEL_BRDGBT("MAT/VEH/VESSEL/BRDGBT"),

    MAT_VEH_VESSEL_CNTSHP("MAT/VEH/VESSEL/CNTSHP"),

    MAT_VEH_VESSEL_CSRSHP("MAT/VEH/VESSEL/CSRSHP"),

    MAT_VEH_VESSEL_CSTSHP("MAT/VEH/VESSEL/CSTSHP"),

    MAT_VEH_VESSEL_DPSMVS("MAT/VEH/VESSEL/DPSMVS"),

    MAT_VEH_VESSEL_FERRY("MAT/VEH/VESSEL/FERRY"),

    MAT_VEH_VESSEL_FIRBOT("MAT/VEH/VESSEL/FIRBOT"),

    MAT_VEH_VESSEL_FLTCRN("MAT/VEH/VESSEL/FLTCRN"),

    MAT_VEH_VESSEL_FLTDRG("MAT/VEH/VESSEL/FLTDRG"),

    MAT_VEH_VESSEL_FLTDRY("MAT/VEH/VESSEL/FLTDRY"),

    MAT_VEH_VESSEL_FREBLK("MAT/VEH/VESSEL/FREBLK"),

    MAT_VEH_VESSEL_FRELIQ("MAT/VEH/VESSEL/FRELIQ"),

    MAT_VEH_VESSEL_HOSSHP("MAT/VEH/VESSEL/HOSSHP"),

    MAT_VEH_VESSEL_HOVCRF("MAT/VEH/VESSEL/HOVCRF"),

    MAT_VEH_VESSEL_ICEBRK("MAT/VEH/VESSEL/ICEBRK"),

    MAT_VEH_VESSEL_LAUNCH("MAT/VEH/VESSEL/LAUNCH"),

    MAT_VEH_VESSEL_LGHTER("MAT/VEH/VESSEL/LGHTER"),

    MAT_VEH_VESSEL_LNDCRF("MAT/VEH/VESSEL/LNDCRF"),

    MAT_VEH_VESSEL_MERSHP("MAT/VEH/VESSEL/MERSHP"),

    MAT_VEH_VESSEL_MOBLS("MAT/VEH/VESSEL/MOBLS"),

    MAT_VEH_VESSEL_OILER("MAT/VEH/VESSEL/OILER"),

    MAT_VEH_VESSEL_PASSGR("MAT/VEH/VESSEL/PASSGR"),

    MAT_VEH_VESSEL_PATVES("MAT/VEH/VESSEL/PATVES"),

    MAT_VEH_VESSEL_POLSPD("MAT/VEH/VESSEL/POLSPD"),

    MAT_VEH_VESSEL_PRV("MAT/VEH/VESSEL/PRV"),

    MAT_VEH_VESSEL_RAFT("MAT/VEH/VESSEL/RAFT"),

    MAT_VEH_VESSEL_RPRSHP("MAT/VEH/VESSEL/RPRSHP"),

    MAT_VEH_VESSEL_SAILVS("MAT/VEH/VESSEL/SAILVS"),

    MAT_VEH_VESSEL_SALSHP("MAT/VEH/VESSEL/SALSHP"),

    MAT_VEH_VESSEL_SMLLBO("MAT/VEH/VESSEL/SMLLBO"),

    MAT_VEH_VESSEL_SUBMAR("MAT/VEH/VESSEL/SUBMAR"),

    MAT_VEH_VESSEL_TANKER("MAT/VEH/VESSEL/TANKER"),

    MAT_VEH_VESSEL_TENDER("MAT/VEH/VESSEL/TENDER"),

    MAT_VEH_VESSEL_TUGBOT("MAT/VEH/VESSEL/TUGBOT"),

    ORG_AMBUL("ORG/AMBUL"),

    ORG_CIVP("ORG/CIVP"),

    ORG_COASTG("ORG/COASTG"),

    ORG_DOCTOR("ORG/DOCTOR"),

    ORG_ENVAGC("ORG/ENVAGC"),

    ORG_FIRFS("ORG/FIRFS"),

    ORG_GEND("ORG/GEND"),

    ORG_HOSP("ORG/HOSP"),

    ORG_IDCOM("ORG/IDCOM"),

    ORG_LCRESF("ORG/LCRESF"),

    ORG_LOCAUT("ORG/LOCAUT"),

    ORG_MARAGC("ORG/MARAGC"),

    ORG_METAGC("ORG/METAGC"),

    ORG_MIL("ORG/MIL"),

    ORG_NGO("ORG/NGO"),

    ORG_POLCNG("ORG/POLCNG"),

    ORG_POLICE("ORG/POLICE"),

    ORG_RGRESF("ORG/RGRESF"),

    ORG_SPADPV("ORG/SPADPV"),

    ORG_TRS("ORG/TRS"),

    ORG_WATAGC("ORG/WATAGC");

    private String value;

    RCLASSEnum(String value) { this.value = value; }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static RCLASSEnum fromValue(String value) {
      for (RCLASSEnum b : RCLASSEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }
  }

  public static final String JSON_PROPERTY_R_C_L_A_S_S = "RCLASS";
  private List<RCLASSEnum> RCLASS = new ArrayList<>();

  public static final String JSON_PROPERTY_C_A_P_A_B_I_L_I_T_Y = "CAPABILITY";
  private List<String> CAPABILITY;

  public static final String JSON_PROPERTY_C_H_A_R_A_C_T_E_R_I_S_T_I_C_S =
      "CHARACTERISTICS";
  private List<String> CHARACTERISTICS;

  public Rtype() {}

  public Rtype RCLASS(List<RCLASSEnum> RCLASS) {

    this.RCLASS = RCLASS;
    return this;
  }

  public Rtype addRCLASSItem(RCLASSEnum RCLASSItem) {
    if (this.RCLASS == null) {
      this.RCLASS = new ArrayList<>();
    }
    this.RCLASS.add(RCLASSItem);
    return this;
  }

  /**
   * Get RCLASS
   * @return RCLASS
   **/
  @JsonProperty(JSON_PROPERTY_R_C_L_A_S_S)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<RCLASSEnum> getRCLASS() {
    return RCLASS;
  }

  @JacksonXmlElementWrapper(useWrapping = false)

  @JsonProperty(JSON_PROPERTY_R_C_L_A_S_S)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setRCLASS(List<RCLASSEnum> RCLASS) {
    if (RCLASS == null) {
      return;
    }
    if (this.RCLASS == null) {
      this.RCLASS = new ArrayList<>();
    }
    this.RCLASS.addAll(RCLASS);
  }

  public Rtype CAPABILITY(List<String> CAPABILITY) {

    this.CAPABILITY = CAPABILITY;
    return this;
  }

  public Rtype addCAPABILITYItem(String CAPABILITYItem) {
    if (this.CAPABILITY == null) {
      this.CAPABILITY = new ArrayList<>();
    }
    this.CAPABILITY.add(CAPABILITYItem);
    return this;
  }

  /**
   * Get CAPABILITY
   * @return CAPABILITY
   **/
  @JsonProperty(JSON_PROPERTY_C_A_P_A_B_I_L_I_T_Y)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<String> getCAPABILITY() {
    return CAPABILITY;
  }

  @JacksonXmlElementWrapper(useWrapping = false)

  @JsonProperty(JSON_PROPERTY_C_A_P_A_B_I_L_I_T_Y)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setCAPABILITY(List<String> CAPABILITY) {
    if (CAPABILITY == null) {
      return;
    }
    if (this.CAPABILITY == null) {
      this.CAPABILITY = new ArrayList<>();
    }
    this.CAPABILITY.addAll(CAPABILITY);
  }

  public Rtype CHARACTERISTICS(List<String> CHARACTERISTICS) {

    this.CHARACTERISTICS = CHARACTERISTICS;
    return this;
  }

  public Rtype addCHARACTERISTICSItem(String CHARACTERISTICSItem) {
    if (this.CHARACTERISTICS == null) {
      this.CHARACTERISTICS = new ArrayList<>();
    }
    this.CHARACTERISTICS.add(CHARACTERISTICSItem);
    return this;
  }

  /**
   * Get CHARACTERISTICS
   * @return CHARACTERISTICS
   **/
  @JsonProperty(JSON_PROPERTY_C_H_A_R_A_C_T_E_R_I_S_T_I_C_S)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<String> getCHARACTERISTICS() {
    return CHARACTERISTICS;
  }

  @JacksonXmlElementWrapper(useWrapping = false)

  @JsonProperty(JSON_PROPERTY_C_H_A_R_A_C_T_E_R_I_S_T_I_C_S)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setCHARACTERISTICS(List<String> CHARACTERISTICS) {
    if (CHARACTERISTICS == null) {
      return;
    }
    if (this.CHARACTERISTICS == null) {
      this.CHARACTERISTICS = new ArrayList<>();
    }
    this.CHARACTERISTICS.addAll(CHARACTERISTICS);
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Rtype rtype = (Rtype)o;
    return Objects.equals(this.RCLASS, rtype.RCLASS) &&
        Objects.equals(this.CAPABILITY, rtype.CAPABILITY) &&
        Objects.equals(this.CHARACTERISTICS, rtype.CHARACTERISTICS);
  }

  @Override
  public int hashCode() {
    return Objects.hash(RCLASS, CAPABILITY, CHARACTERISTICS);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Rtype {\n");
    sb.append("    RCLASS: ").append(toIndentedString(RCLASS)).append("\n");
    sb.append("    CAPABILITY: ")
        .append(toIndentedString(CAPABILITY))
        .append("\n");
    sb.append("    CHARACTERISTICS: ")
        .append(toIndentedString(CHARACTERISTICS))
        .append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
