/**
 * Copyright © 2023-2024 Agence du Numerique en Sante (ANS)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 *
 *
 *
 *
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

package com.hubsante.model.health;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.JsonValue;
import com.fasterxml.jackson.dataformat.xml.annotation.*;
import com.hubsante.model.health.CaseDetails;
import com.hubsante.model.health.HealthMotive;
import com.hubsante.model.health.LocationKind;
import com.hubsante.model.health.RiskThreat;
import com.hubsante.model.health.WhatsHappen;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Arrays;
import java.util.List;
import java.util.Objects;

/**
 * Qualification
 */
@JsonPropertyOrder({Qualification.JSON_PROPERTY_ORIGIN,
                    Qualification.JSON_PROPERTY_RISK_THREAT,
                    Qualification.JSON_PROPERTY_WHATS_HAPPEN,
                    Qualification.JSON_PROPERTY_LOCATION_KIND,
                    Qualification.JSON_PROPERTY_HEALTH_MOTIVE,
                    Qualification.JSON_PROPERTY_DETAILS})
@JsonTypeName("qualification")
@JsonInclude(JsonInclude.Include.NON_EMPTY)

public class Qualification {

  /**
   * A valoriser avec le numéro de provenance de l&#39;appel.
   */
  public enum OriginEnum {
    _15("15"),

    _17("17"),

    _18("18"),

    _112("112"),

    _116117("116117");

    private String value;

    OriginEnum(String value) { this.value = value; }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static OriginEnum fromValue(String value) {
      for (OriginEnum b : OriginEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }
  }

  public static final String JSON_PROPERTY_ORIGIN = "origin";
  private OriginEnum origin;

  public static final String JSON_PROPERTY_RISK_THREAT = "riskThreat";
  private List<RiskThreat> riskThreat;

  public static final String JSON_PROPERTY_WHATS_HAPPEN = "whatsHappen";
  private WhatsHappen whatsHappen;

  public static final String JSON_PROPERTY_LOCATION_KIND = "locationKind";
  private LocationKind locationKind;

  public static final String JSON_PROPERTY_HEALTH_MOTIVE = "healthMotive";
  private HealthMotive healthMotive;

  public static final String JSON_PROPERTY_DETAILS = "details";
  private CaseDetails details;

  public Qualification() {}

  public Qualification origin(OriginEnum origin) {

    this.origin = origin;
    return this;
  }

  /**
   * A valoriser avec le numéro de provenance de l&#39;appel.
   * @return origin
   **/
  @JsonProperty(JSON_PROPERTY_ORIGIN)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public OriginEnum getOrigin() {
    return origin;
  }

  @JsonProperty(JSON_PROPERTY_ORIGIN)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setOrigin(OriginEnum origin) {
    this.origin = origin;
  }

  public Qualification riskThreat(List<RiskThreat> riskThreat) {

    this.riskThreat = riskThreat;
    return this;
  }

  public Qualification addRiskThreatItem(RiskThreat riskThreatItem) {
    if (this.riskThreat == null) {
      this.riskThreat = new ArrayList<>();
    }
    this.riskThreat.add(riskThreatItem);
    return this;
  }

  /**
   * Get riskThreat
   * @return riskThreat
   **/
  @JsonProperty(JSON_PROPERTY_RISK_THREAT)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<RiskThreat> getRiskThreat() {
    return riskThreat;
  }

  @JacksonXmlElementWrapper(useWrapping = false)

  @JsonProperty(JSON_PROPERTY_RISK_THREAT)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setRiskThreat(List<RiskThreat> riskThreat) {
    if (riskThreat == null) {
      return;
    }
    if (this.riskThreat == null) {
      this.riskThreat = new ArrayList<>();
    }
    this.riskThreat.addAll(riskThreat);
  }

  public Qualification whatsHappen(WhatsHappen whatsHappen) {

    this.whatsHappen = whatsHappen;
    return this;
  }

  /**
   * Get whatsHappen
   * @return whatsHappen
   **/
  @JsonProperty(JSON_PROPERTY_WHATS_HAPPEN)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public WhatsHappen getWhatsHappen() {
    return whatsHappen;
  }

  @JsonProperty(JSON_PROPERTY_WHATS_HAPPEN)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setWhatsHappen(WhatsHappen whatsHappen) {
    this.whatsHappen = whatsHappen;
  }

  public Qualification locationKind(LocationKind locationKind) {

    this.locationKind = locationKind;
    return this;
  }

  /**
   * Get locationKind
   * @return locationKind
   **/
  @JsonProperty(JSON_PROPERTY_LOCATION_KIND)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public LocationKind getLocationKind() {
    return locationKind;
  }

  @JsonProperty(JSON_PROPERTY_LOCATION_KIND)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setLocationKind(LocationKind locationKind) {
    this.locationKind = locationKind;
  }

  public Qualification healthMotive(HealthMotive healthMotive) {

    this.healthMotive = healthMotive;
    return this;
  }

  /**
   * Get healthMotive
   * @return healthMotive
   **/
  @JsonProperty(JSON_PROPERTY_HEALTH_MOTIVE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public HealthMotive getHealthMotive() {
    return healthMotive;
  }

  @JsonProperty(JSON_PROPERTY_HEALTH_MOTIVE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setHealthMotive(HealthMotive healthMotive) {
    this.healthMotive = healthMotive;
  }

  public Qualification details(CaseDetails details) {

    this.details = details;
    return this;
  }

  /**
   * Get details
   * @return details
   **/
  @JsonProperty(JSON_PROPERTY_DETAILS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public CaseDetails getDetails() {
    return details;
  }

  @JsonProperty(JSON_PROPERTY_DETAILS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setDetails(CaseDetails details) {
    this.details = details;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Qualification qualification = (Qualification)o;
    return Objects.equals(this.origin, qualification.origin) &&
        Objects.equals(this.riskThreat, qualification.riskThreat) &&
        Objects.equals(this.whatsHappen, qualification.whatsHappen) &&
        Objects.equals(this.locationKind, qualification.locationKind) &&
        Objects.equals(this.healthMotive, qualification.healthMotive) &&
        Objects.equals(this.details, qualification.details);
  }

  @Override
  public int hashCode() {
    return Objects.hash(origin, riskThreat, whatsHappen, locationKind,
                        healthMotive, details);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Qualification {\n");
    sb.append("    origin: ").append(toIndentedString(origin)).append("\n");
    sb.append("    riskThreat: ")
        .append(toIndentedString(riskThreat))
        .append("\n");
    sb.append("    whatsHappen: ")
        .append(toIndentedString(whatsHappen))
        .append("\n");
    sb.append("    locationKind: ")
        .append(toIndentedString(locationKind))
        .append("\n");
    sb.append("    healthMotive: ")
        .append(toIndentedString(healthMotive))
        .append("\n");
    sb.append("    details: ").append(toIndentedString(details)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
