/**
 * Copyright © 2023-2024 Agence du Numerique en Sante (ANS)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 *
 *
 *
 *
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

package com.hubsante.model.resources.info;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.JsonValue;
import com.fasterxml.jackson.dataformat.xml.annotation.*;
import com.hubsante.model.resources.info.Resource;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Arrays;
import java.util.List;
import java.util.Objects;

/**
 * ResourcesInfo
 */
@JsonPropertyOrder({ResourcesInfo.JSON_PROPERTY_CASE_ID,
                    ResourcesInfo.JSON_PROPERTY_MOBILIZED_RESOURCE})
@JsonTypeName("resourcesInfo")
@JsonInclude(JsonInclude.Include.NON_EMPTY)

public class ResourcesInfo {
  @JacksonXmlProperty(isAttribute = true)
  String xmlns = "urn:emergency:cisu:2.0:resourcesInfo";
  public static final String JSON_PROPERTY_CASE_ID = "caseId";
  private String caseId;

  public static final String JSON_PROPERTY_MOBILIZED_RESOURCE =
      "mobilizedResource";
  private List<Resource> mobilizedResource = new ArrayList<>();

  public ResourcesInfo() {}

  public ResourcesInfo caseId(String caseId) {

    this.caseId = caseId;
    return this;
  }

  /**
   * A valoriser avec l&#39;identifiant partagé de l&#39;affaire/dossier, généré
   *une seule fois par le système du partenaire qui recoit la primo-demande de
   *secours (créateur du dossier).  Il est valorisé comme suit lors de sa
   *création :  {pays}.{domaine}.{organisation}.{senderCaseId}  Il doit pouvoir
   *être généré de façon décentralisée et ne présenter aucune ambiguïté.  Il
   *doit être unique dans l&#39;ensemble des systèmes : le numéro de dossier
   *fourni par celui qui génère l&#39;identifiant partagé doit donc être un
   *numéro unique dans son système.
   * @return caseId
   **/
  @JsonProperty(JSON_PROPERTY_CASE_ID)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public String getCaseId() {
    return caseId;
  }

  @JsonProperty(JSON_PROPERTY_CASE_ID)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)
  public void setCaseId(String caseId) {
    this.caseId = caseId;
  }

  public ResourcesInfo mobilizedResource(List<Resource> mobilizedResource) {

    this.mobilizedResource = mobilizedResource;
    return this;
  }

  public ResourcesInfo
  addMobilizedResourceItem(Resource mobilizedResourceItem) {
    if (this.mobilizedResource == null) {
      this.mobilizedResource = new ArrayList<>();
    }
    this.mobilizedResource.add(mobilizedResourceItem);
    return this;
  }

  /**
   * Get mobilizedResource
   * @return mobilizedResource
   **/
  @JsonProperty(JSON_PROPERTY_MOBILIZED_RESOURCE)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public List<Resource> getMobilizedResource() {
    return mobilizedResource;
  }

  @JacksonXmlElementWrapper(useWrapping = false)

  @JsonProperty(JSON_PROPERTY_MOBILIZED_RESOURCE)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)
  public void setMobilizedResource(List<Resource> mobilizedResource) {
    if (mobilizedResource == null) {
      return;
    }
    if (this.mobilizedResource == null) {
      this.mobilizedResource = new ArrayList<>();
    }
    this.mobilizedResource.addAll(mobilizedResource);
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ResourcesInfo resourcesInfo = (ResourcesInfo)o;
    return Objects.equals(this.caseId, resourcesInfo.caseId) &&
        Objects.equals(this.mobilizedResource, resourcesInfo.mobilizedResource);
  }

  @Override
  public int hashCode() {
    return Objects.hash(caseId, mobilizedResource);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ResourcesInfo {\n");
    sb.append("    caseId: ").append(toIndentedString(caseId)).append("\n");
    sb.append("    mobilizedResource: ")
        .append(toIndentedString(mobilizedResource))
        .append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
