/**
 * Copyright © 2023-2024 Agence du Numerique en Sante (ANS)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 *
 *
 *
 *
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

package com.hubsante.model.resources.status;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.JsonValue;
import com.fasterxml.jackson.dataformat.xml.annotation.*;
import java.time.OffsetDateTime;
import java.util.Arrays;
import java.util.Arrays;
import java.util.Objects;

/**
 * ResourcesStatus
 */
@JsonPropertyOrder({ResourcesStatus.JSON_PROPERTY_CASE_ID,
                    ResourcesStatus.JSON_PROPERTY_RESOURCE_ID,
                    ResourcesStatus.JSON_PROPERTY_DATETIME,
                    ResourcesStatus.JSON_PROPERTY_STATUS,
                    ResourcesStatus.JSON_PROPERTY_AVAILABILITY})
@JsonTypeName("resourcesStatus")
@JsonInclude(JsonInclude.Include.NON_EMPTY)

public class ResourcesStatus {
  @JacksonXmlProperty(isAttribute = true)
  String xmlns = "urn:emergency:cisu:2.0:resourcesStatus";
  public static final String JSON_PROPERTY_CASE_ID = "caseId";
  private String caseId;

  public static final String JSON_PROPERTY_RESOURCE_ID = "resourceId";
  private String resourceId;

  public static final String JSON_PROPERTY_DATETIME = "datetime";
  private OffsetDateTime datetime;

  /**
   * A valoriser avec le statut du vecteur. Cf Nomenclature associée.
   */
  public enum StatusEnum {
    DECISION("DECISION"),

    DECLENCHE("DECLENCHE"),

    DEPART("DEPART"),

    ARRIVE("ARRIVE"),

    PEC("PEC"),

    ANNULE("ANNULE"),

    BILAN("BILAN"),

    TRANSPOR("TRANSPOR"),

    ETAPE1("ETAPE1"),

    TRANSP2("TRANSP2"),

    ETAPE2("ETAPE2"),

    TRANSP3("TRANSP3"),

    DESTIN("DESTIN"),

    FINPEC("FINPEC"),

    RETOUR("RETOUR"),

    RET_BASE("RET-BASE"),

    REN_BASE("REN-BASE");

    private String value;

    StatusEnum(String value) { this.value = value; }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StatusEnum fromValue(String value) {
      for (StatusEnum b : StatusEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }
  }

  public static final String JSON_PROPERTY_STATUS = "status";
  private StatusEnum status;

  public static final String JSON_PROPERTY_AVAILABILITY = "availability";
  private Boolean availability;

  public ResourcesStatus() {}

  public ResourcesStatus caseId(String caseId) {

    this.caseId = caseId;
    return this;
  }

  /**
   * A valoriser avec l&#39;identifiant partagé de l&#39;affaire/dossier, généré
   *une seule fois par le système du partenaire qui recoit la primo-demande de
   *secours (créateur du dossier).  Il est valorisé comme suit lors de sa
   *création :  {pays}.{domaine}.{organisation}.{senderCaseId}  Il doit pouvoir
   *être généré de façon décentralisée et ne présenter aucune ambiguïté.  Il
   *doit être unique dans l&#39;ensemble des systèmes : le numéro de dossier
   *fourni par celui qui génère l&#39;identifiant partagé doit donc être un
   *numéro unique dans son système.
   * @return caseId
   **/
  @JsonProperty(JSON_PROPERTY_CASE_ID)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public String getCaseId() {
    return caseId;
  }

  @JsonProperty(JSON_PROPERTY_CASE_ID)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)
  public void setCaseId(String caseId) {
    this.caseId = caseId;
  }

  public ResourcesStatus resourceId(String resourceId) {

    this.resourceId = resourceId;
    return this;
  }

  /**
   * A valoriser avec l&#39;identifiant partagé unique de la ressource engagée ,
   *normé comme suit : {orgID}.R.{ID unique de la ressource partagée} Ou,
   *uniquement dans le cas où un ID unique de ressource ne peut pas être garanti
   *par l&#39;organisation propriétaire : {orgID}.R.{ID du dossier
   *partagé}.{numéro d’ordre chronologique ressource}  N.B. Il s&#39;agit de
   *l&#39;orgId de l&#39;organisation à qui appartient la ressource
   * @return resourceId
   **/
  @JsonProperty(JSON_PROPERTY_RESOURCE_ID)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public String getResourceId() {
    return resourceId;
  }

  @JsonProperty(JSON_PROPERTY_RESOURCE_ID)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)
  public void setResourceId(String resourceId) {
    this.resourceId = resourceId;
  }

  public ResourcesStatus datetime(OffsetDateTime datetime) {

    this.datetime = datetime;
    return this;
  }

  /**
   * A valoriser avec la date et heure de changement du statut.  Si la valeur
   *est vide/inconnue alors c&#39;est le datetime de création du message qui est
   *indiqué.
   * @return datetime
   **/
  @JsonProperty(JSON_PROPERTY_DATETIME)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public OffsetDateTime getDatetime() {
    return datetime;
  }

  @JsonProperty(JSON_PROPERTY_DATETIME)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)
  public void setDatetime(OffsetDateTime datetime) {
    this.datetime = datetime;
  }

  public ResourcesStatus status(StatusEnum status) {

    this.status = status;
    return this;
  }

  /**
   * A valoriser avec le statut du vecteur. Cf Nomenclature associée.
   * @return status
   **/
  @JsonProperty(JSON_PROPERTY_STATUS)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public StatusEnum getStatus() {
    return status;
  }

  @JsonProperty(JSON_PROPERTY_STATUS)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)
  public void setStatus(StatusEnum status) {
    this.status = status;
  }

  public ResourcesStatus availability(Boolean availability) {

    this.availability = availability;
    return this;
  }

  /**
   * A valoriser de manière à indiquer la disponibilité du vecteur. TRUE &#x3D;
   *DISPONIBLE FALSE &#x3D; INDISPONIBLE VIDE &#x3D; INCONNU
   * @return availability
   **/
  @JsonProperty(JSON_PROPERTY_AVAILABILITY)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Boolean getAvailability() {
    return availability;
  }

  @JsonProperty(JSON_PROPERTY_AVAILABILITY)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setAvailability(Boolean availability) {
    this.availability = availability;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ResourcesStatus resourcesStatus = (ResourcesStatus)o;
    return Objects.equals(this.caseId, resourcesStatus.caseId) &&
        Objects.equals(this.resourceId, resourcesStatus.resourceId) &&
        Objects.equals(this.datetime, resourcesStatus.datetime) &&
        Objects.equals(this.status, resourcesStatus.status) &&
        Objects.equals(this.availability, resourcesStatus.availability);
  }

  @Override
  public int hashCode() {
    return Objects.hash(caseId, resourceId, datetime, status, availability);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ResourcesStatus {\n");
    sb.append("    caseId: ").append(toIndentedString(caseId)).append("\n");
    sb.append("    resourceId: ")
        .append(toIndentedString(resourceId))
        .append("\n");
    sb.append("    datetime: ").append(toIndentedString(datetime)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    availability: ")
        .append(toIndentedString(availability))
        .append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
