/**
 * Copyright © 2023-2024 Agence du Numerique en Sante (ANS)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 *
 *
 *
 *
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

package com.hubsante.model.rpis;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.JsonValue;
import com.fasterxml.jackson.dataformat.xml.annotation.*;
import java.util.Arrays;
import java.util.Arrays;
import java.util.Objects;

/**
 * Decision
 */
@JsonPropertyOrder({Decision.JSON_PROPERTY_RESOURCE_CATEGORY,
                    Decision.JSON_PROPERTY_RESOURCE_TYPE,
                    Decision.JSON_PROPERTY_TEAM_CARE})
@JsonTypeName("decision")
@JsonInclude(JsonInclude.Include.NON_EMPTY)

public class Decision {

  /**
   * Précise le type de moyen engagé dans l&#39;intervention (SMUR, TSU, HOSPIT,
   * etc.).  A valoriser par un code de la nomenclature SI SAMU-TYPE_MOYEN.
   */
  public enum ResourceCategoryEnum {
    SMUR("SMUR"),

    HOSPIT("HOSPIT"),

    LIB("LIB"),

    TSU_("TSU "),

    SIS("SIS"),

    AASC("AASC"),

    FDO("FDO"),

    AUTRE("AUTRE");

    private String value;

    ResourceCategoryEnum(String value) { this.value = value; }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ResourceCategoryEnum fromValue(String value) {
      for (ResourceCategoryEnum b : ResourceCategoryEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }
  }

  public static final String JSON_PROPERTY_RESOURCE_CATEGORY =
      "resourceCategory";
  private ResourceCategoryEnum resourceCategory;

  /**
   * Précise le type de véhicule terrestre / aérien / maritime engagé dans
   * l&#39;intervention. A valoriser par un code de la nomenclature
   * CISU-TYPE_VECTEUR.
   */
  public enum ResourceTypeEnum {
    AASC("AASC"),

    VLSC("VLSC"),

    VPSP("VPSP"),

    AUTRESC("AUTRESC"),

    AUTREVEC("AUTREVEC"),

    TAXI("TAXI"),

    TRANSP("TRANSP"),

    TRAIN("TRAIN"),

    AVION("AVION"),

    PERSO("PERSO"),

    APIED("APIED"),

    AUTRE("AUTRE"),

    AUTRETRA("AUTRETRA"),

    FSI("FSI"),

    HELIFSI("HELIFSI"),

    VLFSI("VLFSI"),

    FFSI("FFSI"),

    VHFSI("VHFSI"),

    LIB("LIB"),

    MEDV("MEDV"),

    INF("INF"),

    AUTREPRO("AUTREPRO"),

    SIS("SIS"),

    VSAV("VSAV"),

    GRIMP("GRIMP"),

    VPL("VPL"),

    SRSIS("SRSIS"),

    FEUSIS("FEUSIS"),

    VPMA("VPMA"),

    VCH("VCH"),

    VR("VR"),

    PCSIS("PCSIS"),

    VLISP("VLISP"),

    VLMSP("VLMSP"),

    VLCG("VLCG"),

    VLSIS("VLSIS"),

    DRAGON("DRAGON"),

    AVSC("AVSC"),

    MOYSSE("MOYSSE"),

    AUTRESIS("AUTRESIS"),

    NAVISIS("NAVISIS"),

    SMUR("SMUR"),

    VLM("VLM"),

    VL("VL"),

    PSM1("PSM1"),

    PSM2("PSM2"),

    PSM3("PSM3"),

    PSMP("PSMP"),

    VPC("VPC"),

    AR("AR"),

    AR_BAR("AR-BAR"),

    AR_PED("AR-PED"),

    HELISMUR("HELISMUR"),

    HELISAN("HELISAN"),

    AVSMUR("AVSMUR"),

    AVSAN("AVSAN"),

    NAVISMUR("NAVISMUR"),

    TSU("TSU"),

    VSL("VSL"),

    AMB_GV("AMB-GV"),

    AMB_PV("AMB-PV"),

    AMB_BAR("AMB-BAR"),

    AMB("AMB");

    private String value;

    ResourceTypeEnum(String value) { this.value = value; }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ResourceTypeEnum fromValue(String value) {
      for (ResourceTypeEnum b : ResourceTypeEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }
  }

  public static final String JSON_PROPERTY_RESOURCE_TYPE = "resourceType";
  private ResourceTypeEnum resourceType;

  /**
   * Type d’équipe (médical, paramédicale, secouriste). A valoriser par un code
   * de la nomenclature SI-SAMU-NIVSOIN.
   */
  public enum TeamCareEnum {
    MED("MED"),

    PARAMED("PARAMED"),

    SECOURS("SECOURS");

    private String value;

    TeamCareEnum(String value) { this.value = value; }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TeamCareEnum fromValue(String value) {
      for (TeamCareEnum b : TeamCareEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }
  }

  public static final String JSON_PROPERTY_TEAM_CARE = "teamCare";
  private TeamCareEnum teamCare;

  public Decision() {}

  public Decision resourceCategory(ResourceCategoryEnum resourceCategory) {

    this.resourceCategory = resourceCategory;
    return this;
  }

  /**
   * Précise le type de moyen engagé dans l&#39;intervention (SMUR, TSU, HOSPIT,
   *etc.).  A valoriser par un code de la nomenclature SI SAMU-TYPE_MOYEN.
   * @return resourceCategory
   **/
  @JsonProperty(JSON_PROPERTY_RESOURCE_CATEGORY)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public ResourceCategoryEnum getResourceCategory() {
    return resourceCategory;
  }

  @JsonProperty(JSON_PROPERTY_RESOURCE_CATEGORY)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setResourceCategory(ResourceCategoryEnum resourceCategory) {
    this.resourceCategory = resourceCategory;
  }

  public Decision resourceType(ResourceTypeEnum resourceType) {

    this.resourceType = resourceType;
    return this;
  }

  /**
   * Précise le type de véhicule terrestre / aérien / maritime engagé dans
   *l&#39;intervention. A valoriser par un code de la nomenclature
   *CISU-TYPE_VECTEUR.
   * @return resourceType
   **/
  @JsonProperty(JSON_PROPERTY_RESOURCE_TYPE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public ResourceTypeEnum getResourceType() {
    return resourceType;
  }

  @JsonProperty(JSON_PROPERTY_RESOURCE_TYPE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setResourceType(ResourceTypeEnum resourceType) {
    this.resourceType = resourceType;
  }

  public Decision teamCare(TeamCareEnum teamCare) {

    this.teamCare = teamCare;
    return this;
  }

  /**
   * Type d’équipe (médical, paramédicale, secouriste). A valoriser par un code
   *de la nomenclature SI-SAMU-NIVSOIN.
   * @return teamCare
   **/
  @JsonProperty(JSON_PROPERTY_TEAM_CARE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public TeamCareEnum getTeamCare() {
    return teamCare;
  }

  @JsonProperty(JSON_PROPERTY_TEAM_CARE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setTeamCare(TeamCareEnum teamCare) {
    this.teamCare = teamCare;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Decision decision = (Decision)o;
    return Objects.equals(this.resourceCategory, decision.resourceCategory) &&
        Objects.equals(this.resourceType, decision.resourceType) &&
        Objects.equals(this.teamCare, decision.teamCare);
  }

  @Override
  public int hashCode() {
    return Objects.hash(resourceCategory, resourceType, teamCare);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Decision {\n");
    sb.append("    resourceCategory: ")
        .append(toIndentedString(resourceCategory))
        .append("\n");
    sb.append("    resourceType: ")
        .append(toIndentedString(resourceType))
        .append("\n");
    sb.append("    teamCare: ").append(toIndentedString(teamCare)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
